.386
.model flat,stdcall
option casemap :none  

include \masm32\include\gdi32.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\windows.inc

include MsgLoop.asm

include Objects.inc
include CHDC.asm
include CBButton.asm

includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

; --============================================================================--

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
Paint_Proc   PROTO :DWORD,:DWORD

   ; This is supporting equates for the CreateBlankWindow Macro..
   ;500 ICON MOVEABLE PURE LOADONCALL DISCARDABLE "MAINICON.ICO"
   ; Note: szThisClassName, and szThisDisplayName are also defined..
   
   IDI_MAINICON equ 500
   THIS_WIDTH   equ 178
   THIS_HEIGHT  equ 176+16
   NC_HEIGHT    equ 16
   
; --============================================================================--

.data
   NCArea           RECT { 0, 0, THIS_WIDTH, NC_HEIGHT }
   rctClose         RECT { THIS_WIDTH-14, 2, THIS_WIDTH-2, 14 }
   
   rctRockStar      RECT { 0, 16, THIS_WIDTH, THIS_HEIGHT }
   rctTitle         RECT { 30, 0, 111+30, 16 }
   
   Flag dd 1

.data?
   hInstance        dd   ?
   hIcon            dd   ?
   CommandLine      dd   ?
   
   hDC              dd   ?
   hDC2             dd   ?
   hCloseButton     dd   ?
   hSizeButton      dd   ?
   
   hBitTempUp       dd  ?
   hBitTempDown     dd  ?

   
.code
; --============================================================================--
start:
      invoke GetModuleHandle, NULL
      mov hInstance, eax

      invoke GetCommandLine
      mov CommandLine, eax

      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
      invoke ExitProcess,eax


; --============================================================================--
WinMain proc hInst     :DWORD, hPrevInst :DWORD,
             CmdLine   :DWORD, CmdShow   :DWORD
             
      LOCAL wc      :WNDCLASSEX      
      LOCAL hWnd    :DWORD
      LOCAL msg     :MSG

      mov hWnd, CreateBlankWindow( "AClass", "Gooodness", WndProc )
      
      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:
      
      mov eax, msg.wParam
      ret
WinMain endp      


; --============================================================================--
WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
     LOCAL PS  :PAINTSTRUCT
     LOCAL Rct :RECT
     LOCAL Pt  :POINT

     IF_MSG    WM_DESTROY,         Do_destroy
     IF_MSG    WM_CREATE,          Do_create
     IF_MSG    WM_PAINT,           Do_paint
     IF_MSG    WM_COMMAND,         Do_command
     IF_MSG    WM_LBUTTONDOWN,     Do_LButtonDown
     IF_MSG    WM_DRAWITEM,        Do_DrawItem
     
 @return:  
     invoke    DefWindowProc,hWnd,uMsg,wParam,lParam
     ret
     
 @end:     
     xor eax, eax
     jmp @return

 Do_destroy:  ; ################################################
     
     ; Delete all Bitmap references.
     invoke DeleteObject, $EAX( hSizeButton, CBButton, setButtonDown, hBitTempDown )
     invoke DeleteObject, $EAX( hSizeButton, CBButton, setButtonUp,   hBitTempUp )
     
     ; Destroy the 4 instances created. NOTE: stored bitmaps will be deleted.
     DESTROY hSizeButton
     DESTROY hCloseButton
     DESTROY hDC
     DESTROY hDC2

     invoke PostQuitMessage, NULL
     jmp @end
     
 Do_create:  ; #################################################
 
     ; Create New BUTTON instances
     mov hCloseButton, $NEW( CBButton, hInstance, hWnd, THIS_WIDTH-14, 2, 12, 12, 701, 700 )
     mov hSizeButton,  $NEW( CBButton, hInstance, hWnd, THIS_WIDTH-2*14, 2, 12, 12, 705, 704 )
     
     ; Load needed button bitmaps..
     mov hBitTempUp,   $invoke( LoadBitmap, hInstance, 702 )
     mov hBitTempDown, $invoke( LoadBitmap, hInstance, 703 )
     
     ; Show the window initialy minimized. 
     invoke SetWindowPos, hWnd, HWND_TOPMOST, NULL, NULL, NCArea.right, NCArea.bottom, SWP_NOMOVE 
     
     ; Create a new drawing DC surface for the ROCK StAR picture
     mov hDC, $NEW( CHDC, hWnd, NULL, NULL )
     METHOD hDC, CHDC, SelectObject, HDC_BITMAP, $invoke( LoadBitmap, hInstance, 710 )

     ; Create a new drawing DC surface for the "Rock Star" title image
     mov hDC2, $NEW( CHDC, hWnd, NULL, NULL )
     METHOD hDC2, CHDC, SelectObject, HDC_BITMAP, $invoke( LoadBitmap, hInstance, 711 )
     
     jmp @end

 Do_paint:  ; ##################################################

     
     invoke BeginPaint, hWnd, addr PS
     invoke SetBkMode, PS.hdc, TRANSPARENT
     
     invoke Rectangle, PS.hdc, 0, 0, NCArea.right, NCArea.bottom
     invoke Rectangle, PS.hdc, 0, NCArea.bottom, THIS_WIDTH, THIS_HEIGHT
     invoke DrawIconEx, PS.hdc, 2, 2, hIcon, NC_HEIGHT-2, NC_HEIGHT-2, 0, NULL,  DI_NORMAL

     METHOD hDC2, CHDC, BitBlt, PS.hdc, addr rctTitle       ; Draw title
     METHOD hDC,  CHDC, BitBlt, PS.hdc, addr rctRockStar    ; Draw Picture

     ; Draw Framing Lines to make it look good on a white back window
     invoke MoveToEx, PS.hdc, 0, 16, NULL
     invoke LineTo, PS.hdc, 0, THIS_HEIGHT-1
     invoke LineTo, PS.hdc, THIS_WIDTH-1, THIS_HEIGHT-1
     invoke LineTo, PS.hdc, THIS_WIDTH-1, 15
     invoke LineTo, PS.hdc, 0, 15
     invoke LineTo, PS.hdc, 0, 0
     invoke LineTo, PS.hdc, THIS_WIDTH-1, 0
         
     invoke EndPaint, hWnd, addr PS
 
     jmp @end
 
 Do_command:  ; ################################################
     mov edx, wParam
     shr edx, 16
     .if( edx == BN_CLICKED )
        .if( $EAX(hCloseButton, CBButton, getHandle) == lParam )
           invoke SendMessage, hWnd, WM_CLOSE, NULL, NULL           
        .endif
        
        .if( $EAX(hSizeButton, CBButton, getHandle) == lParam )
           ; Swap button icons (up arrow <--> down arrow)
           push eax
           mov hBitTempUp,   $EAX( hSizeButton, CBButton, setButtonUp,   hBitTempUp)
           mov hBitTempDown, $EAX( hSizeButton, CBButton, setButtonDown, hBitTempDown)
           pop eax
           
           ; Force a button redraw
           invoke InvalidateRect, eax, NULL, FALSE
           
           ; Change Window Size if open or closed..
           xor Flag, TRUE
           .if( Flag == TRUE)
             invoke SetWindowPos, hWnd, HWND_TOPMOST, NULL, NULL, NCArea.right, NCArea.bottom, SWP_NOMOVE 
           .else
             invoke SetWindowPos, hWnd, HWND_TOPMOST, NULL, NULL, THIS_WIDTH, THIS_HEIGHT, SWP_NOMOVE 
           .endif
        .endif
        
     .endif
     jmp @end
     
 Do_LButtonDown:  ; ############################################
     
     mov eax, lParam
     mov edx, eax        ; x point
     and edx, 0ffffh
     shr eax, 16         ; y point
     
     mov Pt.x, edx
     mov Pt.y, eax
     
     ; If clicked in top NON CLIENT area (not really, but im treating it as such)
     ; then send message to be processed as a non-client message.
     .if( $invoke(PtInRect, addr NCArea, edx, eax) == TRUE )
       invoke SendMessage, hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0
     .endif
 
     jmp @end     
  
  Do_DrawItem:  ; ##############################################
     
     ; The message will be specif to one Item, but in the class definition
     ; i choose to check handles before drawing, so if not matched, it will return
     ; and proceed to the next button DrawItem method.  If so, it draws the button.  
     METHOD hCloseButton, CBButton, DrawItem, lParam
     METHOD hSizeButton,  CBButton, DrawItem, lParam
     jmp @end
     
WndProc endp
; --============================================================================--
end start
      